/*   BEM = Batch Equilibrium Model (calculates chemical equilibira)
     Copyright (C) 1996  J. Prenzel (jprenze@gwdg.de)
     
     This program is free software; you can redistribute it and/or
     modify it under the terms of the GNU General Public License
     as published by the Free Software Foundation; either version 2
     of the License, or (at your option) any later version.
     
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.         */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include "bem.h"


void showmod();

/*....................................... main ...................*/                                
int tinit(char *mfile){
  int rc;
  

  CALL(rc,makecl("test"));
  Mod.nam=mfile;
  CALL(rc,openfiles('m'));
  CALL(rc,openfiles('l'));
  CALL(rc,modinit());
  CALL(rc,init0());
  showmod();
  return 0;
}

/*.............................................. showmod ..............*/
void showmod(){
  short i,ii,z;
  double a;
  printf("Eine Zelle bentigt zur Zeit %d bytes.\n",sizeof(CLL));
  printf("\nEin Element bentigt zur Zeit %d bytes.\n",sizeof(ELT));
  printf("Anzahl der Elemente = %d\n",Cl->nelt);
  for(i=0;i<Cl->nelt;i++){
    printf("%5d.) %8s %4d\n",i,Cl->el[i]->name,Cl->el[i]->chrg);
  }
  printf("\nEin Komplex bentigt zur Zeit %d bytes.\n",sizeof(CPL));
  printf("Anzahl der Komplexe = %d\n",Cl->ncpl);
  for(i=0;i<Cl->ncpl;i++){
    printf("%5d.) %32s %16g %4d\n",i,Cl->cp[i]->name
          ,Cl->cp[i]->lnkds/-M_LN10  ,Cl->cp[i]->chrg);
    for (ii=0;ii<Cl->cp[i]->nelt;ii++){
      printf(">>>>>>>> %4d   %s   %d\n",ii,Cl->cp[i]->el[ii]->name\
             ,Cl->cp[i]->stcf[ii]);
    }
  }
  printf("\nEin Salz    bentigt zur Zeit %d bytes.\n",sizeof(SLT));
  printf("Anzahl der Salze    = %d\n",Cl->nslt);
  for(i=0;i<Cl->nslt;i++){
    printf("%5d.) %32s %16g    \n",i,Cl->sl[i]->name
          ,Cl->sl[i]->spfpar[0] );
    for (ii=0;ii<Cl->sl[i]->nelt;ii++){
      printf(">>>>>>>> %4d   %s   %d\n",ii,Cl->sl[i]->el[ii]->name\
             ,Cl->sl[i]->stcf[ii]);
    }
  }
  printf("\nStartwerte: estph %g, eststr %g, theta0 %g, rho %g\n"
         ,Cl->estph,Cl->eststr,Cl->theta0,Cl->rho);

  printf("\nctl0, estsng, ctot0   :\n");
  for(i=0;i<Cl->nelt;i++){
    printf("%4d%8s  %g  %g  %g\n",i,Cl->el[i]->name,Cl->el[i]->ctl0
           ,Cl->el[i]->estsng, Cl->el[i]->ctot);
  }
  printf("\ncslt0,  estslt   :\n");
  for(i=0;i<Cl->nslt;i++){
    printf("%4d%24s  %g  %g\n",i,Cl->sl[i]->name,Cl->sl[i]->cslt0
           ,Cl->sl[i]->estslt);
  }

  if(Cl->niex >0){
    printf("\ncec = %g mmolc/kg; pKsel: \n",Cl->xc->xcap*1.e3);
    for(i=2;i<Cl->nelt;i++){
      z=Cl->el[i]->chrg;
      if(z>0){
	a = -Cl->xc->lnksel[i]/M_LN10;
	printf("%8s %g\n",Cl->el[i]->name,a);
      }
    }
  }
  return;
}



